"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var useForceRenders_1 = require("../hooks/useForceRenders");
var tools_1 = require("../utils/tools");
function createConnect(registers) {
    /**
    * Register component for render by key name
    * @param keyName key name
    * @param index index
    */
    function connect(keyName, index) {
        return function (Component) {
            function WrappedComponent(props) {
                var _a = useForceRenders_1.useForceRender(), forceRender = _a[1];
                function setRegister() {
                    var connection = {
                        keyName: keyName,
                        index: index,
                        render: forceRender,
                        props: props
                    };
                    registers.set(tools_1.__keyNameIndex__(keyName, index), connection);
                }
                function deleteRegister() {
                    registers.delete(tools_1.__keyNameIndex__(keyName, index));
                }
                react_1.useEffect(function () {
                    setRegister();
                    return function () {
                        deleteRegister();
                    };
                }, []);
                setRegister();
                return react_1.default.createElement(Component, __assign({}, props));
            }
            return WrappedComponent;
        };
    }
    return connect;
}
exports.default = createConnect;
