"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var useForceRenders_1 = require("../hooks/useForceRenders");
var tools_1 = require("../utils/tools");
function createUseRender(registers) {
    /**
    * Hook where the render will be generated by its keyName
    * @param keyName keyName to identify by render
    * @param index its additional
    */
    function useRender(keyName, index) {
        var _a = useForceRenders_1.useForceRender(), forceRender = _a[1];
        function setRegister() {
            var hook = {
                keyName: keyName,
                index: index,
                render: forceRender
            };
            registers.set(tools_1.__keyNameIndex__(keyName, index), hook);
        }
        function deleteRegister() {
            registers.delete(tools_1.__keyNameIndex__(keyName, index));
        }
        react_1.useEffect(function () {
            setRegister();
            return function () {
                deleteRegister();
            };
        }, []);
        setRegister();
    }
    return useRender;
}
exports.default = createUseRender;
