"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function tools(registers) {
    /**
     * Returns the props received per connection by the parent component
     * @param keyName KeyName of connection
     * @returns props
     */
    function getProps(keyName) {
        var register = registers.get(keyName) || {};
        function instanceOfConnection(object) {
            return 'props' in object;
        }
        if (instanceOfConnection(register)) {
            return register.props;
        }
        return null;
    }
    return {
        getProps: getProps
    };
}
exports.default = tools;
